// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/include/adadio_utils.h $
// $Rev: 52444 $
// $Date: 2023-01-30 13:29:24 -0600 (Mon, 30 Jan 2023) $

// ADADIO: Utilities: header file

#ifndef	__ADADIO_UTILS_H__
#define	__ADADIO_UTILS_H__

#include "adadio_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	adadio_close_util			(int fd, int index, int verbose);
int adadio_init_util			(int verbose);
int adadio_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	adadio_open_util			(int device, int share, int index, int verbose, int* fd);
int	adadio_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);

// IOCTL utility services

int	adadio_ain_buf_clear		(int fd, int index, int verbose);								// ADADIO_IOCTL_AIN_BUF_CLEAR
int	adadio_ain_buf_enable		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AIN_BUF_ENABLE
int	adadio_ain_buf_size			(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AIN_BUF_SIZE
int adadio_ain_buf_sts			(int fd, int index, int verbose, s32* get);						// ADADIO_IOCTL_AIN_BUF_STS
int adadio_ain_chan_last		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AIN_CHAN_LAST
int	adadio_ain_mode				(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AIN_MODE
int adadio_ain_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AIN_NRATE
int	adadio_ain_trigger			(int fd, int index, int verbose);								// ADADIO_IOCTL_AIN_TRIGGER
int adadio_aout_ch_0_write		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AOUT_CH_0_WRITE
int adadio_aout_ch_1_write		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AOUT_CH_1_WRITE
int adadio_aout_ch_2_write		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AOUT_CH_2_WRITE
int adadio_aout_ch_3_write		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AOUT_CH_3_WRITE
int	adadio_aout_enable			(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AOUT_ENABLE
int	adadio_aout_strobe			(int fd, int index, int verbose);								// ADADIO_IOCTL_AOUT_STROBE
int	adadio_aout_strobe_enable	(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_AOUT_STROBE_ENABLE
int	adadio_auto_calibrate		(int fd, int index, int verbose);								// ADADIO_IOCTL_AUTO_CALIBRATE
int	adadio_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_DATA_FORMAT
int	adadio_dio_pin_read			(int fd, int index, int verbose, s32* get);						// ADADIO_IOCTL_DIO_PIN_READ
int	adadio_dio_pin_write		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_DIO_PIN_WRITE
int	adadio_dio_port_dir			(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_DIO_PORT_DIR
int	adadio_dio_port_read		(int fd, int index, int verbose, s32* get);						// ADADIO_IOCTL_DIO_PORT_READ
int	adadio_dio_port_write		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_DIO_PORT_WRITE
int	adadio_initialize			(int fd, int index, int verbose);								// ADADIO_IOCTL_INITIALIZE
int	adadio_irq_sel				(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_IRQ_SEL
int adadio_loopback_channel		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_LOOPBACK_CHANNEL
int	adadio_query				(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_QUERY
int	adadio_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// ADADIO_IOCTL_REG_MOD
int adadio_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// ADADIO_IOCTL_REG_READ
int adadio_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// ADADIO_IOCTL_REG_WRITE
int	adadio_rx_io_abort			(int fd, int index, int verbose, s32* get);						// ADADIO_IOCTL_RX_IO_ABORT
int	adadio_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_RX_IO_MODE
int	adadio_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// ADADIO_IOCTL_RX_IO_TIMEOUT
int	adadio_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// ADADIO_IOCTL_WAIT_CANCEL
int	adadio_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// ADADIO_IOCTL_WAIT_EVENT
int	adadio_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// ADADIO_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	adadio_config_ai			(int fd, int index, int verbose);
int adadio_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int adadio_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int adadio_id_device			(int fd, int index, int verbose);

int	adadio_count_boards			(int verbose, s32* get);
int adadio_reg_list				(int fd, int detail);

const gsc_reg_def_t*			adadio_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*			adadio_reg_get_def_index	(int index);
const char*						adadio_reg_get_desc			(u32 reg);
const char*						adadio_reg_get_name			(u32 reg);



#endif
