// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/samples/sbtest/query.c $
// $Rev: 52466 $
// $Date: 2023-01-30 13:55:32 -0600 (Mon, 30 Jan 2023) $

// ADADIO: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service ADADIO_IOCTL_QUERY. We test only the
*		overall service, not the values returned.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	gsc_label("ADADIO_IOCTL_QUERY");
	errs	= adadio_query(fd, -1, 0, ADADIO_QUERY_COUNT, &count);

	if (count != (ADADIO_QUERY_LAST))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) ADADIO_QUERY_LAST,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i < ADADIO_QUERY_LAST); i++)
			errs	= adadio_query(fd, -1, 0, i, &data);

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


