// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/utils/util_aout_ch_1_write.c $
// $Rev: 44402 $
// $Date: 2019-02-06 13:38:11 -0600 (Wed, 06 Feb 2019) $

// ADADIO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	adadio_aout_ch_1_write
*
*	Purpose:
*
*		Provide a visual wrapper for the ADADIO_IOCTL_AOUT_CH_1_WRITE service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int adadio_aout_ch_1_write(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Channel 1 Output", index);

	ret		= adadio_ioctl(fd, ADADIO_IOCTL_AOUT_CH_1_WRITE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%04lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


